# parsl.providers.cluster_provider.ClusterProvider

class parsl.providers.cluster_provider.ClusterProvider(label, nodes_per_block, init_blocks, min_blocks, max_blocks, parallelism, walltime, launcher, cmd_timeout=10)

  This class defines behavior common to all cluster/supercompute-style scheduler systems.

  Parameters:

    - label (str) – Label for this provider.

    - walltime (str) – Walltime requested per block in HH:MM:SS.

    - launcher (Launcher) – Launcher for this provider.

    - cmd_timeout (int) – Timeout for commands made to the scheduler in seconds

                            +------------------
                            |
      script_string ------->|  submit
           id      <--------|---+
                            |
      [ ids ]       ------->|  status
      [statuses]   <--------|----+
                            |
      [ ids ]       ------->|  cancel
      [cancel]     <--------|----+
                            |
                            +-------------------

  __init__(label, nodes_per_block, init_blocks, min_blocks, max_blocks, parallelism, walltime, launcher, cmd_timeout=10)

  Methods

  `__init__`(label, nodes_per_block, ...[, ...]) |
  `cancel`(job_ids) | Cancels the resources identified by the job_ids provided by the user.
  `execute_wait`(cmd[, timeout]) |
  `status`(job_ids) | Get the status of a list of jobs identified by the job identifiers returned from the submit request.
  `submit`(command, tasks_per_node[, job_name]) | The submit method takes the command string to be executed upon instantiation of a resource most often to start a pilot (such as for HighThroughputExecutor or WorkQueueExecutor).

  Attributes

  `label` | Provides the label for this provider
  `status_polling_interval` | Returns the interval, in seconds, at which the status method should be called.

  execute_wait(cmd, timeout=None)
  property label

    Provides the label for this provider

  status(job_ids)

    Get the status of a list of jobs identified by the job identifiers returned from the submit request.

    Parameters:

      job_ids (-) – A list of job identifiers

    Returns:

      - A list of JobStatus objects corresponding to each job_id in the job_ids list.

    Raises:

      - ExecutionProviderException or its subclasses –